extensions [gis
  ]
globals
[
  forest-map
  hr                                             ;; home-range
  hrng                                           ;; home-range number generator
  tnhr                                           ;; total number of home-ranges in the model landscape
  cds                                            ;; counter for deer setup
  d                                              ;; counter that resets every 12 months
  cps                                            ;; counter for patch setup
  afd                                            ;; adult female deer on the patch counter
  xx                                             ;; counter for displaced female deer during initial setup
  mad                                            ;; male adult deer
  fad                                            ;; female adult deer
  myd                                            ;; male yearling deer
  fyd                                            ;; female yearling deer
  mfd                                            ;; male fawn deer
  ffd                                            ;; female fawn deer
  ;mf6nhm                                        ;; male fawn non-hunting mortality upto 6 months
  ;ff6nhm                                        ;; female fawn non-hunting mortality upto 6 months
  ;mf12nhm                                       ;; male fawn non-hunting mortality 6-12 months
  ;ff12nhm                                       ;; female fawn non-hunting mortality 6-12 months
  ;mynhm                                         ;; male yearling non-hunting mortality
  ;fynhm                                         ;; female yearling non-hunting mortality
  ;manhm                                         ;; male adult non-hunting mortality
  ;fanhm                                         ;; female adult non-hunting mortality
  ;mf6hm                                         ;; male fawn hunting mortality upto 6 months 00000
  ;ff6hm                                         ;; female fawn hunting mortality upto 6 months 0000
  ;mf12hm                                        ;; male fawn hunting mortality 6-12 months
  ;ff12hm                                        ;; female fawn hunting mortality 6-12 months
  ;myhm                                          ;; male yearling hunting mortality
  ;fyhm                                          ;; female yearling hunting mortality
  ;mahm                                          ;; male adult hunting mortality
  ;fahm                                          ;; female adult hunting mortality
  mf
  my
  ma
  ff
  fy
  fa
  fhr
  dc
  dxp                                           ;; xcord prior to disp movement
  dxn                                           ;; ycord after disp movement
  dyp
  dyn
  counter
  fhp                                            ;; finalize home-patch after dispersal
  ddohrn                                         ;; dispersing deer original hrn
  mdd                                            ;; mean dispersal distance
  sddd                                           ;; std dev dispersal distance
  dd                                             ;; predicted dispersal distance from log-normal pdf
  lv
  lm
  ls                                             ;; parameters for calculating log-normal pdf of dd
  ndd                                            ;; number of deer dispersing out of the landscape
  nhrn                                           ;; new home range number
  vv
  year
  td
  phn
  ncwd                                           ;; to set no of cwd deer every year
  mcwd
  mycwd                                         ;;22Jan16
  mfcwd                                         ;;22Jan16
  fcwd
  fycwd                                         ;;22Jan16
  ffcwd                                         ;;22Jan16
  dcwdm
  dcwdmy                                        ;;22Jan16
  dcwdmf                                        ;;22Jan16
  dcwdf
  dcwdfy                                        ;;22Jan16
  dcwdff                                        ;;22Jan16
  tcwdm
  tcwdf                                         ;;tested cwd male/female
  hcwd
  tcwd
  totcwdd
  pdcwd                                         ;; probability of detecting CWD
  vals1                                          ;; for excel output
  vals2
  vals3
  vals
  op                                            ;;observed prevalence
  tamh                                          ;; tot adult male deer hunted
  tymh                                          ;;22Jan16
  tafh
  tyfh                                          ;;22Jan16
  tamt                                          ;; tot adult male deer tested
  taft
  peramht                                       ;; percent adult male harvest tested
  perafht

  dcp                                           ;; to calculate number of patches where CWD is clustered
  ndcp                                          ;; counter to count dcl patches
  nadh                                          ;; number of adult deer hunted-------------------------------------new global for male-biased sampling model
  nadt                                          ;; number of adult deer tested-------------------------------------
  pertestm
  pertestf
  pidc
  piss1
  piss2
  piss
  sse                                            ;; sampling strategy efficiency
  ano                                            ;; for inf process---11mar15
  ano2
  ;;=================================================================================added on 23July15
  mom                                            ;; mom's who
  cdf                                            ;; counter for female deer in the landscape
  cdl                                            ;; counter for deer leaders
  mgs                                            ;; mean group size
  ;;=================================================================================added on 27July15
  tgs                                            ;;transfer post-harvest group size
  ndag                                           ;; number of deer available for grouping
  tgroid
  gs
  zz
  zz1      ;; temporary counter to be deleted
  zz2      ;; temp counter to count deers with sex = 2 and aim > 18 < 29 (while transferring group leadership) 16 Sep 15
  ttgroid  ;; temp counter for transfer of leadership process when leader dies/ is hunted 7 Sep 15
  ;;===============================
  twho     ;; transfer who for new code in to die 20 Sep 15
  counter1
  tmomid
  tgr
  ;;===============================22Nov15
  oldm                ;;%old males (above 229 when d = 1) of total adult males
  oldf                ;;old females (above 229 when d = 1) of total adult females
  ;;================================2Dec15
  osg                 ;;oversized group
  osg1                ;;counter
  sd                  ;;solitary females
  sd1                 ;;counter
  ;;==============================21Dec15
  ttmomid             ;;for identifying adult siblings
  ttaim               ;; same
  ;;===============================29Dec15
  tmbg                ;; total male bachelor groups at d=1
  mean-bachelor-group-size                 ;; male bachelor group size
  tmgroid             ;;
  cgs                 ;;
  cgs1                ;;24May16
  potcand             ;;
  ;;==============================14Jan16
  tnm                 ;; to transfer the nm value
  ter                 ;; mating area (more for young deers)
  infm
  inff
  avmates
  tinff
  ;===============================11Feb16
  cwdpd
  grfis               ;; group fission 10Jun16
  tttgroid            ;;16Jun16 for testing
  ngr                 ;;30Jul16
  posthpop
  tot_harvest
  tmfh
  tffh
  tmyh
  tfyh
  ;------------------
  min%ForestCover
  max%ForestCover
  doe-group-size-regulator
  breeding-prop-female-fawns
  yearling-male-dispersal-rate
  yearling-female-dispersal-rate
  mean-female-dispersal-distance
  stddev-dispersal-distance
  ;rregion
]

patches-own
[
  forest-percent
  dh                                             ;; home-range number
  do                                             ;; deer occupancy 0/1male/2female)
  border                                         ;; identifying border patches
  dfp
  dcl                                            ;; patches where CWD is clustered:::PATCH STATUS 1: CWDclusterpatch;0: noncluster patch; 3 patch with 1 or more cwd+ deer; 4 patch where deer/s tested and found +; 2 buffer patch

]
breed [deers deer]
deers-own
[
  sex
  aim                                            ;;age in months
  ;cwd
  ;cwdm                                           ;; when a deer will die post cwd infection
  ;cwdi                                           ;; when a deer will become infectious post cwd inf
  ;cwdc                                           ;; when a deer will show clinical signs post cwd inf
  ;cwdpr                                          ;; cwd progression in months
  momid                                           ;; mother's who number
  gl                                              ;; 1 group leader; 0 follower
  ;;========================added on 23July15
  groid
  gr                                             ;; basically a leader attribute-group size excluding the leader (0 to n); if -1 the deer (gl = 0) is in a group; -2 if the deer is not in a group
  ;============================29Dec15
  ml                                             ;; male bachelor group leader ml = 1 otherwise 0
  mgroid                                         ;; male bachelor group -2 at birth, -1 after dispersal and = who of leader when join group as adults
  ]

;;************************************************************************************************************************
;*************************************************************************************************************************
;*************************************************************************************************************************

to setup
  clear-all
  setup-landscape
  if (Recommended_parameter_values = TRUE)[
    ;set PostHarvestDensity 20
    set sexratio 120
    set adultprop 0.40
    set yearlingprop 0.25
    set mf6nhm 0.055
    set ff6nhm 0.055
    set mf12nhm 0.05
    set ff12nhm 0.05
    set mynhm 0.01
    set fynhm 0.00
    set manhm 0.01
    set fanhm 0.02
    set mf6hm 0
    set ff6hm 0
    set mf12hm 0.05
    set ff12hm 0.02
    set myhm 0.25
    set fyhm 0.15
    set mahm 0.40
    set fahm 0.20
    ]
  file-open (word "c:/Users/" machine "/Desktop/DeerPopDy" Region ".csv");########################ensure correct path to the desired folder on your computer is substituted here
  file-print "posth_mf,posth_my,posth_ma,posth_ff,posth_fy,posth_fa,posth_total,preh_mf,preh_my,preh_ma,preh_ff,preh_fy,preh_fa,preh_total,mf_harvest,my_harvest,ma_harvest,ff_harvest,fy_harvest,fa_harvest,total_harvest"
  file-close
  reset-ticks
end

to setup-landscape
  if (Region = "BooneCounty")[
    resize-world 0 24 0 41
    set forest-map gis:load-dataset "boone_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 17
      ]
    ]
  if (Region = "CallawayCounty")[
    resize-world 0 31 0 34
    set forest-map gis:load-dataset "callaway_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 26
      ]
    ]
  if (Region = "CarrollCounty")[
    resize-world 0 35 0 27
    set forest-map gis:load-dataset "carroll_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 37
      ]
    ]
  if (Region = "CharitonCounty")[
    resize-world 0 31 0 33
    set forest-map gis:load-dataset "chariton_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 36
      ]
    ]
  if (Region = "ColeCounty")[
    resize-world 0 26 0 28
    set forest-map gis:load-dataset "cole_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 14
      ]
    ]
  if (Region = "CooperCounty")[
    resize-world 0 30 0 26
    set forest-map gis:load-dataset "cooper_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 24
      ]
    ]
  if (Region = "FranklinCounty")[
    resize-world 0 34 0 34
    set forest-map gis:load-dataset "franklin_forestpercentcover1.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 23
      ]
    ]
  if (Region = "GasconadeCounty")[
    resize-world 0 15 0 38
    set forest-map gis:load-dataset "gasconade_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 25
      ]
    ]
  if (Region = "KnoxCounty")[
    resize-world 0 21 0 24
    set forest-map gis:load-dataset "knox_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 42
      ]
    ]
  if (Region = "LinnCounty")[
    resize-world 0 27 0 23
    set forest-map gis:load-dataset "linn_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 45
      ]
    ]
  if (Region = "LivingstonCounty")[
    resize-world 0 26 0 24
    set forest-map gis:load-dataset "livingston_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 37
      ]
    ]
  if (Region = "MillerCounty")[
    resize-world 0 27 0 28
    set forest-map gis:load-dataset "miller_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 17
      ]
    ]
  if (Region = "MoniteauCounty")[
    resize-world 0 24 0 34
    set forest-map gis:load-dataset "moniteau_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 16
      ]
    ]
  if (Region = "MorganCounty")[
    resize-world 0 24 0 34
    set forest-map gis:load-dataset "morgan_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 35
      ]
    ]
  if (Region = "OsageCounty")[
    resize-world 0 29 0 28
    set forest-map gis:load-dataset "osage_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 18
      ]
  ]
  if (Region = "PutnamCounty")[
    resize-world 0 37 0 16
    set forest-map gis:load-dataset "putnam_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 29
      ]
    ]
  if (Region = "RandolphCounty")[
    resize-world 0 21 0 24
    set forest-map gis:load-dataset "randolph_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 31
      ]
    ]
  if (Region = "StCharlesCounty")[
    resize-world 0 45 0 30
    set forest-map gis:load-dataset "stcharles_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 35
      ]
    ]
  if (Region = "StLouisCounty")[
    resize-world 0 32 0 34
    set forest-map gis:load-dataset "stlouis_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 50
      ]
    ]
  if (Region = "SchuylerCounty")[
    resize-world 0 19 0 17
    set forest-map gis:load-dataset "schuyler_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 36
      ]
    ]
  if (Region = "ScotlandCounty")[
    resize-world 0 21 0 20
    set forest-map gis:load-dataset "scotland_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 49
      ]
    ]
  if (Region = "ShelbyCounty")[
    resize-world 0 23 0 23
    set forest-map gis:load-dataset "shelby_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 46
      ]
    ]
  if (Region = "SullivanCounty")[
    resize-world 0 26 0 24
    set forest-map gis:load-dataset "sullivan_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 32
      ]
    ]
  if (Region = "WarrenCounty")[
    resize-world 0 24 0 30
    set forest-map gis:load-dataset "warren_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 28
      ]
    ]
  if (Region = "WashingtonCounty")[
    resize-world 0 25 0 32
    set forest-map gis:load-dataset "washington_forestpercentcoverAB.asc";"spr1_export_percentforestcover2.asc" ;forest_percentcover.asc"
    if (Recommended_parameter_values = TRUE)[
      set PostHarvestDensity 31
      ]
    ]

  gis:set-world-envelope gis:envelope-of forest-map
  gis:apply-raster forest-map forest-percent

  set min%ForestCover 0.25
  set max%ForestCover 0.75
  set doe-group-size-regulator 6
  set breeding-prop-female-fawns 20
  set yearling-male-dispersal-rate .46                      ;dispersal rates for yearling males range between 46% to 80% (Long et al., 2005)
  set yearling-female-dispersal-rate .22
  set mean-female-dispersal-distance 11
  set stddev-dispersal-distance 4
  set mean-bachelor-group-size (1 + random-normal 4 1)


  ask patches [
    set border 0
    ]

  let brown-patches patches with [forest-percent = 0]
  ask brown-patches [ ;with [forest-percent = 0] [
    set pcolor brown
    set dh -1
    ]

  let pborder1 patches with-max [pxcor]
  ask pborder1 [;patches with-max [pxcor] [
    set border 1
  ]
  let pborder2 patches with-min [pxcor]
  ask pborder2 [;patches with-min [pxcor] [
    set border 2
  ]
  let pborder3 patches with-max[pycor]
  ask pborder3 [;patches with-max [pycor] [
    ifelse (border > 0)
    [ifelse (border > 1)
      [set border 8]                                       ;;upper left
      [set border 5]                                       ;;upper right
    ]
    [set border 3]
  ]
  let pborder4 patches with-min [pycor]
  ask pborder4 [;patches with-min [pycor] [
    ifelse (border > 0)
    [ifelse (border > 1)
      [set border 7]                                       ;;lower left
      [set border 6]                                       ;;lower right
    ]
    [set border 4]
  ]


  let optfc patches with [forest-percent >= min%ForestCover]
  ask optfc [;patches with [forest-percent >= min%ForestCover] [
    ifelse (forest-percent <= max%ForestCover)
    [set do 1
      set hrng (hrng + 1)
      set dh hrng ;hrn
      ]
    [set do 2]
    ]

  let belowoptfc patches with [forest-percent < min%ForestCover and forest-percent > 0]
  ask belowoptfc [;patches with [forest-percent < min%ForestCover and forest-percent > 0] [
    set do 3
    ]

  let do2patches patches with [do = 2]
  ask do2patches [;patches with [do = 2][
    let aa (count neighbors with [do = 3])
    ifelse (aa >= 1)
    [set hr (forest-percent)
      set hrng (hrng + 1)
      set dh (hrng) ;hrn
      set do 1
      ask one-of neighbors with [do = 3][
        set hr (hr + forest-percent)
        set dh (hrng) ; hrn
        set do 1]
      ]
    [set do 5]
    ]
  let do3patches patches with [do = 3]
  ask do3patches [;patches with [do = 3][
  if any? neighbors with [do = 3][
    set hr forest-percent
    let nhr sum [forest-percent] of neighbors with [do = 3]
    if (hr + nhr >= min%ForestCover)[
      set hrng hrng + 1
      set dh hrng
      set do 1
      ask neighbors with [do = 3][
        set dh hrng
        set do 1
      ]
      ]
    ]
  ]
  ask patches with [do > 1][
    set do -1
    ]
  set tnhr (max [dh] of patches)
  ask patches with [dh > 0] [
    set pcolor scale-color blue dh 1 tnhr
    ]
  ask patches with [dh > 0][
    set pcolor scale-color green forest-percent 1 0
    ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

let hrn-patches patches with [dh > 0]
let mp (precision (100 / (100 + sexratio))4) * 100
let madp (precision (mp * adultprop) 2)
let myp (precision (mp * yearlingprop) 2)
let fadp (precision ((1 - mp) * adultprop) 2)
let fyp (precision ((1 - mp) * yearlingprop) 2)
ask hrn-patches [
  set cds (cds + 1)
  ifelse (cds > tnhr)
  [stop]
  [set xx 0
    while [xx < PostHarvestDensity]
    [let current-patch one-of patches with [dh = cds] ;hrn
      ask current-patch [
        sprout-deers 1 [                                                 ;; post-hunting (Jan) deer density per sq.mile
          set shape "deer"
          set color orange
          set size 1.5
          ;set cwdm 20 + random 6
          ;set cwdi 3 + random 2                                           ;; if infected with cwd, will become infectious after 3 or 4 months post inf
          ;set cwdc 15 + random 4                                          ;; if infected, becomes clinical between 15 and 18 months
          set groid -1
          set aim 0
          ifelse (random-float 100 < mp)                                  ;46:54 male:female ratio
          [set sex 1                                                      ;; 1=male
            set gr -2
            ifelse (random-float mp < madp)
            [set aim (20 + ((1 + random 14) * 12))
              set mad mad + 1
              set mgroid -1]
            [ifelse (random-float (mp - madp) < myp)
              [set aim 20
                set myd myd + 1
                set mgroid -1]
            [set aim 8
              set mgroid -2
              set mfd mfd + 1]
            ]
            ]
          [set sex 2                                                      ;; 2=female
            ifelse (random-float (1 - mp) < fadp)
            [set aim (20 + ((1 + random 14) * 12))
              set fad fad + 1
              ifelse (random-float 1 < 0.5)
              [set gl 1
                ]
              [set gl 0]
              ]
            [ifelse (random-float ((1 - mp) - fadp) < fyp)
              [set aim 20
                set fyd fyd + 1]
            [set aim 8
              set ffd ffd + 1]
            ]
            ]
          ]
        set xx (xx + 1)
        ]
      ]
    ]
  ]


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
let pot-leaders deers with [gl = 1 ]
ask pot-leaders [
  set groid who
  set tgroid groid
  let pgr abs (round random-normal 2 1)
  set ndag (count deers in-radius-nowrap 1.5 with [sex = 2 and gl = 0 and gr = 0])
  if (ndag > 0)[
    ifelse (ndag >= pgr)
    [ask n-of pgr deers in-radius-nowrap 1.5 with [sex = 2 and gl = 0 and gr = 0][
      set gr -1
      set groid tgroid
      ]
    set gr pgr
    ]
    [ask n-of ndag deers in-radius-nowrap 1.5 with [sex = 2 and gl = 0 and gr = 0][
      set gr -1
      set groid tgroid
      ]
    set gr ndag;
    ]
    ]

   if (gr = 0)[
     set gl 0
     set groid -1
     ]
   ]


 ask deers with [sex = 2 and gl = 0 and groid = -1 and gr = 0][
   set gr -2
 ]

 ;;====================================================================================================
 set td count deers
 let nb-patches patches with [border = 0]
 ask nb-patches [;patches with [border = 0] [
   let tff forest-percent
   let nff sum [forest-percent] of neighbors
   set dfp (tff + nff) / 9
 ]
 let b-patches patches with [border >= 1]
 ask b-patches [;patches with [border >= 1][
   ask one-of neighbors with [border = 0] [
     set vv dfp
   ]
   set dfp vv
 ]

 end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to go
  if (ticks = 311) [
   stop
  ]

  set d ((remainder (ticks) 12) + 1)

  ask deers [
    individual-growth
    deer-die
  ]
  if (d < 10) [
    let male-leaders deers with [ml = 1]
    ask male-leaders [
      set tmgroid mgroid
      set gr (count deers with [mgroid = tmgroid])
      ]
    ]
  if (d = 10)[
    let male-leaders deers with [ml = 1]
    ask male-leaders [
      set gr 0     ;mgr to gr
      ]
    ]

  if (d = 1) [
    let mfawns deers with [sex = 1 and aim < 12.5]
    set mf (count mfawns)

    let ffawns deers with [sex = 2 and aim < 12.5]
    set ff (count ffawns)

    let myearlings deers with [sex = 1 and aim = 21]
    set my (count myearlings)

    let fyearlings deers with [sex = 2 and aim = 21]
    set fy (count fyearlings)

    let madults deers with [sex = 1 and aim > 30]
    set ma (count madults)

    let fadults deers with [sex = 2 and aim > 30]
    set fa (count fadults)

    set posthpop (mf + ff + my + fy + ma + fa)
    set vals1 (list (mf) (my) (ma) (ff) (fy) (fa) (posthpop))

    set tmbg ((my + ma) / 4)
    let male-leaders deers with [ml = 1]
    let count-ml count male-leaders
    let pot-leaders deers with [sex = 1 and aim > 32 and ml = 0]
    if (tmbg > count-ml)[
      ask n-of (tmbg - count-ml) pot-leaders [
        set ml 1
        set mgroid who
        ]
      ]
    set male-leaders deers with [ml = 1]
    ask male-leaders [
      bachelor-group-formation
    ]
    ask male-leaders [
      set tmgroid mgroid
      set gr (count deers with [mgroid = tmgroid])    ;mgr to gr
    ]
    set year (year + 1)
    set td (mf + my + ma + ff + fy + fa)

    set oldm precision ((count deers with [sex = 1 and aim >= 229]) / ma) 3
    set oldf precision ((count deers with [sex = 2 and aim >= 229]) / fa) 3
  ]

  if (d = 5) [
    let male-yearlings deers with [aim = 13 and sex = 1]
    ask male-yearlings [
      set tgroid groid
      if (gr = -1) [
        ask deer tgroid [
          set gr (gr - 1)
          if (gr <= 0) [
            set gl 0
            set groid -1
            set gr -2
            set zz1 (zz1 + 1)
            ]
          ]
        ]

      set gr -2
      set groid -1
      if (random-float 1 < yearling-male-dispersal-rate) [
        set mgroid -1
        deer-mdisperse
        ]
      ]
    let female-yearlings deers with [aim = 13 and sex = 2]
    ask female-yearlings [
      if (random-float 1 < yearling-female-dispersal-rate)[     ;11April 0.22 to yearling-female-dispersal-rate
        set tgroid groid
        if (gr = -1)[
          ask deer tgroid[
            set gr (gr - 1)
            if (gr <= 0)[
              set gl 0
              set groid -1
              set gr -2
              set zz1 (zz1 + 1)
              ]
            ]
          ]

        set gr -2
        set groid -1
        deer-fdisperse
        ]
      ]
    let breeding-females deers with [sex = 2 and aim > 12]
    ask breeding-females [
      if (aim = 13) [
        if (random 100 <= breeding-prop-female-fawns)[   ;7April17 21 replaced with breeding-prop-female-fawns
          set grfis 0
          set tgroid groid
          ifelse (tgroid >= 0)
          [ask deer tgroid [
              ifelse (gr > (doe-group-size-regulator - 2))       ;7April17 4 replaced with doe-group-size-regulator - 2
              [set gr (gr - 1)
                set tgroid -1
                set tgr -2
                set grfis 1
              ]
              [set gr (gr + 1)
                set tgroid groid
                set tgr -1
              ]
              ]
          if (grfis = 1)[
            set groid -1
            set gr -2
          ]
          ]
          [set tgroid -1
            set tgr -2
          ]
          deer-reproduce
          ]
        ]
      if (aim > 24)[
        if (random 100 < 81)[
          set grfis 0
          set tgroid groid
          ifelse (gl > 0)
          [set gr (gr + 2)
            if (gr > doe-group-size-regulator)[
              let xgr gr - doe-group-size-regulator
              let group-members deers with [groid = tgroid and sex = 2 and aim > 13 and gl = 0]
              ifelse (count group-members >= xgr)
              [set ngr xgr]
              [set ngr count group-members]
              ask n-of ngr group-members [
                new-group-formation
                ]
              ]
            set tgr -1
            ]
          [ifelse (groid < 0)
            [ifelse (aim > 36 and zz1 > 0)                ;27Jun16 added to prevent declining numbers of females with (gl =1 )
              [set gl 1
                set gr 2
                set groid who
                set tgroid who
                set tgr -1
                set zz1 (zz1 - 1)
                ]
              [set tgroid -1
                set tgr -2
                ]
              ]
            [ask deer tgroid [
                ifelse (gr > 4)
                [set gr (gr - 1)
                  set tgroid -1
                  set tgr -2
                  set grfis 1
                ]
                [set gr (gr + 2)
                  set tgroid groid
                  set tgr -1
                ]
            ]
            if (grfis = 1)[
              set groid -1
              set gr -2
              ]
            ]
            ]
          deer-reproduce
          ]
      ]
      ;;;;---------------------------JOIN-GROUP-------------------------------------------------------------------------

      if (gl = 1 and gr < 4)[
        set tgroid groid
        let solitary-adult-females-here deers in-radius-nowrap 1.5 with [sex = 2 and gr = -2 and aim >= 13]
        set sd count solitary-adult-females-here
        set tgr 0
        if (sd > 0)[
          ifelse (sd > 2)
          [set sd1 2]
          [set sd1 1]
          ask n-of sd1 solitary-adult-females-here [
            set tmomid who
            set groid tgroid
            set gr -1
            set tgr (tgr + 1)
            if any? deers with [momid = tmomid and aim = 1][
              let my-fawns deers with [momid = tmomid and aim = 1]
              ask my-fawns [
                set groid tgroid
                set gr -1
                set tgr (tgr + 1)
                ]
              ]
            ]
          ]
        set gr (gr + tgr)
        if (gr = 0)[
          set groid -1
          set gr -2
        ]
        ]
      ]
    ]


  if (d = 11) [
    let solitary-male-yearlings deers with [sex = 1 and aim = 19 and gr = -2 and mgroid = -2]
    ask solitary-male-yearlings [
      if (random-float 1 < yearling-male-dispersal-rate) [
        set mgroid -1
        deer-mdisperse
        ]
      set mgroid -1
      ]
    ;=============================================14Jan16==deer mating submodel==========
    let female-deers deers with [sex = 2]
;    ask female-deers [
;      set nm (1 + random 3)                                   ;33333333333333333333333333333333333 5April17
;      set anm 0
;    ]
;    let breeding-males deers with [sex = 1 and aim > 18]
;    ask breeding-males [
;      deer-mating
;    ]

    ;========================================
    let male-fawns deers with [sex = 1 and aim < 12.5]
    set mf (count male-fawns)
    let female-fawns deers with [sex = 2 and aim < 12.5]
    set ff (count female-fawns)
    let male-yearlings deers with [sex = 1 and aim = 19]
    set my (count male-yearlings)
    let female-yearlings deers with [sex = 2 and aim = 19]
    set fy (count female-yearlings)
    let adult-males deers with [sex = 1 and aim > 30]
    set ma (count adult-males)
    let adult-females deers with [sex = 2 and aim > 30]
    set fa (count adult-females)
    ;========================================11Jan16
    set phn (mf + my + ma + ff + fy + fa)
    set vals2 (list (mf) (my) (ma) (ff) (fy) (fa) (phn))
    if (ticks = 310) [
      export-world (word "prehpop" Region ".csv")
    ]
  ]

  if (d = 12) [
    ask deers [
      if (aim < 10)[
        ifelse (sex = 1)
        [if (random-float 1 < mf12hm)[
            set tgroid groid
            hunting-mortality-mf12
            ]
        ]
        [if (random-float 1 < ff12hm)[
            set tgroid groid
            set twho who
            hunting-mortality-ff12
            ]
        ]
        ]
      if (aim = 20)[
        ifelse (sex = 1)
        [if (random-float 1 < myhm)[
            set tgroid groid
            hunting-mortality-my
            ]
        ]
        [if (random-float 1 < fyhm)[
            set tgroid groid
            set twho who
            hunting-mortality-fy
            ]
        ]
        ]
      if (aim > 30)[
        ifelse (sex = 1)
        [if (random-float 1 < mahm)[
            set tgroid groid
            hunting-mortality-ma
            ]
        ]
        [if (random-float 1 < fahm)[
            set tgroid groid
            set twho who
            hunting-mortality-fa
            ]
        ]
        ]
      ]

    set tot_harvest (tmfh + tmyh + tamh + tffh + tfyh + tafh)
    set vals3 (list (tmfh) (tmyh) (tamh) (tffh) (tfyh) (tafh) (tot_harvest))
    set vals (sentence vals1 vals2 vals3)
    file-open (word "c:/Users/" machine "/Desktop/DeerPopDy" Region ".csv") ;###########################Ensure correct path to the folder on your computer is substituted here
    file-type first vals
    foreach but-first vals [ [?1] ->
      file-type "," file-type ?1
    ]
    file-print""
    file-close

    set ndd 0


    if (ticks < 310) [
      set mf 0
      set my 0
      set ma 0
      set ff 0
      set fy 0
      set fa 0
      set tamt 0
      set tamh 0
      set taft 0
      set tafh 0
      set tmfh 0
      set tffh 0
      set tmyh 0
      set tfyh 0
      set tot_harvest 0

      ]
    ]
  set-current-plot "deer population"
  plotxy ticks count deers
  tick
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to individual-growth
  set aim (aim + 1)
end


;;==========================================DEER REPRODUCE==========================================================

to deer-reproduce
  set mom who
  ifelse (aim < 13.5)
  [hatch-deers 1[
    set aim 1
    set shape "deer"                                 ;;unnecessary?
    set color orange                                 ;;unnecessary?
    set size 1.5                                     ;;unnecessary?
    set gl 0
    ;set cwd 0
    ;set cwdm 20 + random 6
    ;set cwdi 3 + random 2
    ;set cwdc 15 + random 4
    set momid mom
    set groid tgroid
    set gr tgr
    ifelse random 100 < 51
    [set sex 1
      set mgroid -2]
    [set sex 2]
    ]
  ]
  [hatch-deers 2[
    set aim 1
    set shape "deer"                               ;; unnecessary
    set color orange                               ;; unnecessary
    set size 1.5
    set gl 0
    ;set cwd 0
    ;set cwdm 20 + random 6
    ;set cwdi 3 + random 2
    ;set cwdc 15 + random 4
    set momid mom
    set groid tgroid
    set gr tgr
    ifelse random 100 < 51
    [set sex 1
      set mgroid -2]
    [set sex 2]
    ]
    ]

end
;=====================================================================================================================
;=====================================================================================================================

to deer-mdisperse
  ask patch-here [
    if (dfp < .72) [
      set mdd (35.07 - (48.14 * (dfp)))                                   ;; relationship between mean dispersal distance and proportion of forest cover to estimate the mean dispersal distance Long et al., 2005; Difenbach et al., 2008
      set sddd sqrt(e ^ (3.51 + (0.077 * mdd)))
      set lv ln (1 + (sddd ^ 2) / (mdd ^ 2))
      set lm ln mdd - (lv / 2)
      set ls sqrt lv
      set dd (exp (random-normal lm ls) * .6214)                          ;; this is in miles, 1 patch fd is 1 mile, so fd dd
      ]
  ]
  set counter 0
  rt random 360
  while [counter < round dd]
  [ask patch-here [
      set dxp (pxcor)
      set dyp (pycor)
      set ddohrn dh  ;hrn
    ]
    fd 1
    set counter counter + 1
    ask patch-here [
      set dxn (pxcor)
      set dyn (pycor)
    ]
    if (abs(dxn - dxp) > 1 or abs(dyn - dyp) > 1)
    [set ndd ndd + 1
      ;set cwd 0                                                      ;; ASSUMPTION: Deer dispersing INTO the landscape are CWD-free.
      ;set cwdm 20 + random 6
      ;set cwdi 3 + random 2
      ;set cwdc 15 + random 4
      set momid 0]
  ]
  finalize-home-patch
end

to deer-fdisperse
  set counter 0
  rt random 360
  set dd round (random-normal mean-female-dispersal-distance stddev-dispersal-distance)   ; 11April17 18 replaced with mean-female-dispersal-distance and 6 with stddev-dispersal-distance
  while [counter < dd]
  [ask patch-here [
      set dxp (pxcor)
      set dyp (pycor)
      set ddohrn dh    ;hrn
  ]
  fd 1
  set counter counter + 1
  ask patch-here [
    set dxn (pxcor)
    set dyn (pycor)
  ]
  if (abs(dxn - dxp) > 1 or abs(dyn - dyp) > 1)
  [set ndd ndd + 1
    ;set cwd 0
    ;set cwdm 20 + random 6
    ;set cwdi 3 + random 2
    ;set cwdc 15 + random 4
    set momid 0
    ]
  ]
  finalize-home-patch
end


to finalize-home-patch
  ask patch-here [
    ifelse (do = 1)
    [set nhrn dh]     ;hrn
    [set fhp 1]
  ]
  if (fhp > 0)[
    set dxp (pxcor)
    set dyp (pycor)
    move-to min-one-of patches with [do = 1] [distance myself]
    set color blue
    ask patch-here [
      set dxn (pxcor)
      set dyn (pycor)
      set nhrn dh      ;hrn
    ]
    if (abs(dxn - dxp) > 1 or abs(dyn - dyp) > 1)                     ;; dispersing deer goes out of the model landscape
    [set ndd ndd + 1
      ;set cwd 0
      ;set cwdm 20 + random 6
      ;set cwdi 3 + random 2
      ;set cwdc 15 + random 4
      set momid 0
      ]
    set fhp 0
    ]

end
;;================================================================================================

to new-group-formation
  set tgroid groid
  set groid -1
  set ttgroid who
  set tgr 0
  if any? deers with [momid = ttgroid and aim = 1][
    let my-fawns deers with [momid = ttgroid and aim = 1]
    ask my-fawns [
      set gr -2
      set groid -1
      set tgr (tgr + 1)
      ]
    ]
  set gr -2
  ask deer tgroid[
    set gr (gr - (tgr + 1))
  ]
end
;;================================================================================================
to deer-die
  set tgroid groid
  if (sex = 2)[
    set twho who
  ]
  ;============================================================== fawns upto 6 months
  ifelse (aim < 6.5)
  [ifelse (sex = 1)
    [if precision (random-float 1) 3 < mf6nhm [ ;6April17 mfmo6 replaced with mf6nhm
        if (gr = -1)[
          set ttgroid groid
          ask deer ttgroid[
            set gr (gr - 1)
            if (gr <= 0)[
              set gl 0
              set groid -1
              set gr -2
              set zz1 (zz1 + 1)
              ]
            ]
        ]
        die
        ]
    ]
    [if precision (random-float 1) 3 < ff6nhm [ ;6April17 replaced ffmo6 with ff6nhm
        if (gr = -1)[
          set ttgroid groid
          ask deer ttgroid[
            set gr (gr - 1)
            if (gr <= 0)[
              set gl 0
              set groid -1
              set gr -2
              set zz1 (zz1 + 1)
              ]
            ]
          ]
        die
        ]
    ]
    ]
  ;================================================================ 7 to 12 months
  [ifelse (aim < 12.5)
    [ifelse (sex = 1)
      [if random-float 1 < mf12nhm [ ;6April17 replaced mfmo12 with mf12nhm
          if (gr = -1)[
            set ttgroid groid
            ask deer ttgroid[
              set gr (gr - 1)
              if (gr <= 0)[
                set gl 0
                set groid -1
                set gr -2
                set zz1 (zz1 + 1)
                ]
              ]
          ]
          die
          ]
      ]
      [if random-float 1 < ff12nhm [ ;6April17 replaced ffmo12 with ff12nhm
          if (gr = -1)[
            set ttgroid groid
            ask deer ttgroid[
              set gr (gr - 1)
              if (gr = 0)[
                set gl 0
                set groid -1
                set gr -2
                set zz1 (zz1 + 1)
                ]
              ]
          ]

          die
          ]
      ]
      ]
    ;=============================================================== 13 to 24
    [ifelse (aim < 24.5)
      [ifelse (sex = 1)
        [if random-float 1 < mynhm [ ;6April17 replaced mymonh with mynhm
            if (gr = -1)[
              set ttgroid groid
              ask deer ttgroid[
                set gr (gr - 1)
                if (gr <= 0)[
                  set gl 0
                  set groid -1
                  set gr -2
                  set zz1 (zz1 + 1)
                  ]
                ]
            ]
            die
            ]
        ]
        [if random-float 1 < fynhm [ ;6April17 replaced fymonh with fynhm
            if any? deers with [momid = twho and aim < 2.5][
              let my-fawns deers with [momid = twho and aim < 2.5]
              ask my-fawns [
                set counter1 counter1 + 1
                die
              ]
            ]
            ifelse (gl > 0)
            [let pot-groupleaders deers with [groid = tgroid and gl = 0 and sex = 2 and aim >= 18]
              ifelse (count pot-groupleaders > 0)
              [ask one-of pot-groupleaders [
                  set ttgroid who
                  set gl 1
                  set groid ttgroid
                  let transfer-group deers with [groid = tgroid and gl = 0]
                  if (count transfer-group > 0)[
                    ask transfer-group [
                      set groid ttgroid
                      ]
                  ]
                  let new-group deers with [groid = ttgroid and gl = 0]
                  set gr (count new-group)
                  ]
              ]
              [let other-groupleaders-here deers-here with [gl = 1 and groid != tgroid and gr < 3]
                ifelse (count other-groupleaders-here > 0)
                [ask one-of other-groupleaders-here[
                    set ttgroid groid
                    let transfer-deers deers with [groid = tgroid and gl = 0]
                    set gr (gr + count transfer-deers)
                    ]
                let new-group deers with [groid = tgroid and gl = 0]
                ask new-group [
                  set groid ttgroid
                  ]
                ]
                [let group-members deers with [groid = tgroid and gl = 0]
                  ask group-members[
                    set gr -2
                    set groid -1
                    ]
                ]
                set zz1 (zz1 + 1)
                ]
              ]
            [if (gr = -1)[
                set ttgroid groid
                ask deer ttgroid[
                  set gr (gr - (counter1 + 1))
                  if (gr <= 0)[
                    set gl 0
                    set groid -1
                    set gr -2
                    set zz1 (zz1 + 1)
                    ]
                  ]
                ]
            ]
            set counter1 0
            die
            ]
        ]
        ]
      ;=================================================================male 25 to 240 and more than 240
      [ifelse (sex = 1)
        [ifelse (aim < 240)
          [if random-float 1 < precision (manhm - oldm) 3 [
              if (ml = 1)[
                set tmgroid mgroid
                let my-group deers with [mgroid = tmgroid]
                ask my-group[
                  set mgroid -1
                ]
              ]
              die
              ]
          ]
          [if random-float 1 < .8 [
              if (ml = 1)[
                set tmgroid mgroid
                let my-group deers with [mgroid = tmgroid]
                ask my-group[
                  set mgroid -1
                  ]
                ]
              die
              ]
          ]
          ]
        ;===============================================================female 25 to 240
        [ifelse (aim < 240)
          [if random-float 1 < precision (fanhm - oldf) 3 [ ;6April17 replaced famonh with fanhm
              let my-fawns deers with [momid = twho and aim < 2.5]
              if (count my-fawns > 0)[
                ask my-fawns[;deers with [momid = twho and aim < 2.5][
                  set counter1 counter1 + 1
                  die
                ]
              ]
              ifelse (gl > 0)
              [let pot-groupleaders deers with [groid = tgroid and aim > 18 and sex = 2 and gl = 0]
                set zz count pot-groupleaders
                ifelse (zz > 0)
                [ifelse (any? pot-groupleaders with [aim > 29])
                  [ask one-of pot-groupleaders with [aim > 29][
                      set gl 1
                      set ttgroid who
                      set groid ttgroid
                      let my-group deers with [groid = tgroid and gl = 0]
                      ask my-group [
                        set groid ttgroid
                        ]
                      let new-group deers with [groid = ttgroid and gl = 0]
                      set gr (count new-group)
                      ]
                  ]
                  [ask one-of pot-groupleaders [
                      set gl 1
                      set ttgroid who
                      set groid ttgroid
                      let my-group deers with [groid = tgroid and gl = 0]
                      ask my-group [
                        set groid ttgroid
                        ]
                      let new-group deers with [groid = ttgroid and gl = 0]
                      set gr (count new-group)
                      ]
                  ]
                ]
                [let other-groupleaders-here deers-here with [gl = 1 and groid != tgroid and gr < 3]
                  ifelse (count other-groupleaders-here > 0)
                  [ask one-of other-groupleaders-here [
                      set ttgroid groid
                      let add-deers deers with [groid = tgroid and gl = 0]
                      set gr (gr + count add-deers)
                      ]
                  let new-group deers with [groid = tgroid and gl = 0]
                  ask new-group[
                    set groid ttgroid
                    ]
                  ]
                  [let group-members deers with [groid = tgroid and gl = 0]
                    ask group-members[
                      set gr -2
                      set groid -1
                      ]
                    ]
                  set zz1 (zz1 + 1)
                  ]
                ]

              [if (gr = -1)[
                  set ttgroid groid
                  ask deer ttgroid[
                    set gr (gr - (counter1 + 1))
                    if (gr <= 0)[
                      set gl 0
                      set groid -1
                      set gr -2
                      set zz1 (zz1 + 1)
                      ]
                    ]
                  ]
              ]
              set counter1 0
              die
              ]
          ]
          ;============================================================female 240 and more
          [if random-float 1 < .8 [
              if any? deers with [momid = twho and aim < 2.5][
                let my-fawns deers with [momid = twho and aim < 2.5]
                ask my-fawns [
                  set counter1 counter1 + 1
                  die
                ]
              ]

              ifelse (gl > 0)
              [let pot-groupleaders deers with [groid = tgroid and aim > 18 and sex = 2 and gl = 0]
                set zz count pot-groupleaders;deers with [groid = tgroid and aim > 18 and sex = 2 and gl = 0]
                ifelse (zz > 0)
                [ifelse (any? pot-groupleaders with [aim > 29])
                  [ask one-of pot-groupleaders with [aim > 29][
                    set gl 1
                    set ttgroid who
                    set groid ttgroid
                    let my-group deers with [groid = tgroid and gl = 0]
                    ask my-group[;deers with [groid = tgroid and gl = 0][
                      set groid ttgroid
                      ]
                    let new-group deers with [groid = ttgroid and gl = 0]
                    set gr (count new-group)
                    ]
                  ]
                  [ask one-of pot-groupleaders [
                    set gl 1
                    set ttgroid who
                    set groid ttgroid
                    let my-group deers with [groid = tgroid and gl = 0]
                    ask my-group[
                      set groid ttgroid
                      ]
                    let new-group deers with [groid = ttgroid and gl = 0]
                    set gr (count new-group)
                    ]
                  ]
                ]
                [let other-groupleaders-here deers-here with [gl = 1 and groid != tgroid and gr < 3]
                  ifelse (count other-groupleaders-here > 0)
                 [ask one-of other-groupleaders-here [
                   set ttgroid groid
                   let my-group deers with [groid = tgroid and gl = 0]
                   set gr (gr + count my-group)
                   ]
                 let new-group deers with [groid = tgroid and gl = 0]
                 ask new-group[
                   set groid ttgroid
                   ]
                 ]
                  [let my-group deers with [groid = tgroid and gl = 0]
                    ask my-group [
                      set gr -2
                      set groid -1
                      ]
                    ]
                  set zz1 (zz1 + 1)
                  ]
              ]
              [if (gr = -1)[
                  set ttgroid groid
                  ask deer ttgroid [
                    set gr (gr - (counter1 + 1))
                    if (gr <= 0)[
                      set gl 0
                      set groid -1
                      set gr -2
                      set zz1 (zz1 + 1)
                      ]
                    ]
                  ]
              ]
              set counter1 0
              die
              ]
          ]
        ]
      ]
    ]
  ]

end

to hunting-mortality-mf12
  if (gr = -1)[
    ask deer tgroid[
      set gr (gr - 1)
      if (gr <= 0)[
        set gl 0
        set groid -1
        set gr -2
        set zz1 (zz1 + 1)
        ]
      ]
    ]
;  if (cwd = 1)[
;    set dcwdmf (dcwdmf + 1)
;  ]
  set tmfh tmfh + 1
  die
end
;=====================================
to hunting-mortality-ff12
  if (gr = -1)[
    ask deer tgroid[
      set gr (gr - 1)
      if (gr <= 0)[
        set gl 0
        set groid -1
        set gr -2
        set zz1 (zz1 + 1)
        ]
      ]
    ]
;  if (cwd = 1)[
;    set dcwdff (dcwdff + 1)
;  ]
  set tffh tffh + 1
  die
end
;====================================
to hunting-mortality-my
;  if (cwd = 1)[
;    set dcwdmy (dcwdmy + 1)
;    ]
  set tmyh tmyh + 1
  die
end

to hunting-mortality-fy
  ifelse (gl > 0)
  [let pot-groupleaders deers with [groid = tgroid and gl = 0 and sex = 2 and aim >= 18]
    ifelse (count pot-groupleaders > 0)
    [ask one-of pot-groupleaders [
      set ttgroid who
      set gl 1
      set groid ttgroid
      let transfer-group deers with [groid = tgroid and gl = 0]
      let xgr count transfer-group
      ask transfer-group [
        set groid ttgroid
        ]
      set gr xgr
      ]
    ]
    [let other-groupleaders-here deers with [gl = 1 and groid != tgroid and gr < 3]
      ifelse (count other-groupleaders-here > 0)
      [ask one-of other-groupleaders-here [
          set ttgroid groid
          let transfer-group deers with [groid = tgroid and gl = 0]
          set gr (gr + count deers with [groid = tgroid and gl = 0])
          ]
      let new-group deers with [groid = tgroid and gl = 0]
      ask new-group[
        set groid ttgroid
        ]
      ]
      [let group-members deers with [groid = tgroid and gl = 0]
        ask group-members [
          set gr -2
          set groid -1
          ]
      ]
      set zz1 (zz1 + 1)
      ]
    ]

  [if (gr = -1)[
      ask deer tgroid[
        set gr (gr - 1)
        if (gr <= 0)[
          set gl 0
          set groid -1
          set gr -2
          set zz1 (zz1 + 1)
          ]
        ]
      ]
  ]
;  if (cwd = 1)[
;    set dcwdfy (dcwdfy + 1)
;    ]
  set tfyh tfyh + 1                               ;6April17
  die
end
;==========================================22Jan16
to hunting-mortality-ma
  if (ml = 1)[
    set tmgroid mgroid
    let group-members deers with [mgroid = tmgroid and ml = 0]
    ask group-members [
      set mgroid -1
      ]
    ]
  ifelse (random-float 1 < permah)                         ;;percent of male adult harvest tested set by the slider
  [;if (cwd = 1) [
      ;set dcwdm (dcwdm + 1)
      ;set tcwdm (tcwdm + 1)
      ;]
  set tamh tamh + 1
  set tamt tamt + 1
  die
  ]
  [;if (cwd = 1) [
      ;set dcwdm (dcwdm + 1)
      ;]
  set tamh tamh + 1
  die
  ]
end
;=========================================
to hunting-mortality-fa
  ifelse (random-float 1 < perfah)
  [;if (cwd = 1)[
      ;set dcwdf (dcwdf + 1)
      ;set tcwdf (tcwdf + 1)
      ;]
  set tafh tafh + 1
  set taft taft + 1
  if (gl = 1)[
    let pot-groupleaders deers with [groid = tgroid and sex = 2 and aim > 18 and gl = 0]
    set zz count pot-groupleaders
    ifelse (zz > 0)
    [ifelse (any? pot-groupleaders with [aim > 29])
      [ask one-of pot-groupleaders with [aim > 29][
          set gl 1
          set ttgroid who
          set groid ttgroid
          let transfer-group deers with [groid = tgroid and gl = 0]
          let xtr count transfer-group
          ask transfer-group[
            set groid ttgroid
            ]
          set gr xtr
          ]
      ]
      [ask one-of pot-groupleaders [
          set gl 1
          set ttgroid who
          set groid ttgroid
          let transfer-group deers with [groid = tgroid and gl = 0]
          let xtr count transfer-group
          ask transfer-group [
            set groid ttgroid
            ]
          set gr xtr
          ]
      ]
      ]
    [let other-groupleaders-here deers-here with [gl = 1 and groid != tgroid and gr < 3]
      ifelse (count other-groupleaders-here > 0)
      [ask one-of other-groupleaders-here [
        set ttgroid groid
        let transfer-group deers with [groid = tgroid and gl = 0]
        let xtr count transfer-group
        set gr (gr + xtr)
       ]

      let new-group deers with [groid = tgroid and gl = 0]
      ask new-group [
        set groid ttgroid
        ]
      ]
      [let transfer-group deers with [groid = tgroid and gl = 0]
        ask transfer-group[
          set gr -2
          set groid -1
          ]
      ]
      set zz1 (zz1 + 1)
      ]
    ]
  if (gr = -1)[
    ask deer tgroid[
      set gr (gr - 1)
      if (gr <= 0)[
        set gl 0
        set groid -1
        set gr -2
        set zz1 (zz1 + 1)
        ]
      ]
    ]
  die
  ]
  [;if (cwd = 1)[
      ;set dcwdf (dcwdf + 1)
      ;]
  set tafh tafh + 1
  if (gl = 1)[
    let pot-groupleaders deers with [groid = tgroid and sex = 2 and aim > 18 and gl = 0]
    set zz count pot-groupleaders
    ifelse (zz > 0)
    [ifelse (any? pot-groupleaders with [aim > 29])
      [ask one-of pot-groupleaders with [aim > 29][
        set gl 1
        set ttgroid who
        set groid ttgroid
        let transfer-group deers with [groid = tgroid and gl = 0]
        let xtr count transfer-group
        ask transfer-group [
          set groid ttgroid
          ]
        set gr xtr
       ]
      ]
      [ask one-of pot-groupleaders [
        set gl 1
        set ttgroid who
        set groid ttgroid
        let transfer-group deers with [groid = tgroid and gl = 0]
        let xtr count transfer-group
        ask transfer-group [
          set groid ttgroid
          ]
        set gr xtr
        ]
      ]
    ]
    [let other-groupleaders-here deers-here with [gl = 1 and groid != tgroid and gr < 3]
      ifelse (count other-groupleaders-here > 0)
      [ask one-of other-groupleaders-here [
       set ttgroid groid
       let transfer-group deers with [groid = tgroid and gl = 0]
       let xtr count transfer-group
       set gr (gr + xtr)
       ask transfer-group [
         set groid ttgroid
         ]
       ]
      ]
      [let transfer-group deers with [groid = tgroid and gl = 0]
        ask transfer-group [
          set gr -2
          set groid -1
          ]
      ]
      set zz1 (zz1 + 1)
      ]
    ]

  if (gr = -1)[
    ask deer tgroid[
      set gr (gr - 1)
      if (gr <= 0)[
        set gl 0
        set groid -1
        set gr -2
        set zz1 (zz1 + 1)
        ]
      ]
    ]

  die
  ]
end

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++^^^^^^^^^^^^^^^^inactivated 22Jan16++++++++++++++++++++++++++++++


to deer-count
  ifelse (sex = 1)
  [ifelse (aim < 12.5)
    [set mf (mf + 1)]
    [ifelse (aim < 24.5)
      [set my (my + 1)]
      [set ma (ma + 1)]
    ]
  ]
  [ifelse (aim < 12.5)
    [set ff (ff + 1)]
    [ifelse (aim < 24.5)
      [set fy (fy + 1)]
      [set fa (fa + 1)]
    ]
  ]
end

to bachelor-group-formation
  set tmgroid mgroid
  ;set mean-bachelor-group-size (1 + random-normal 4 1)
  let group-members deers in-radius-nowrap 1.5 with [mgroid = tmgroid and ml = 0]
  set cgs (count group-members)
  if (cgs < mean-bachelor-group-size) [
    let pot-groupmembers-here deers in-radius-nowrap 1.5 with [mgroid = -1 and ml = 0]
    set cgs1 (count pot-groupmembers-here)
    ifelse (cgs1 >= (mean-bachelor-group-size - cgs))
    [ask n-of (mean-bachelor-group-size - cgs) pot-groupmembers-here [
        set mgroid  tmgroid
        ]
    ]
    [if (cgs1 > 0)[
        ask n-of cgs1 pot-groupmembers-here [
          set mgroid tmgroid
        ]
    ]
    ]
    ]



end

;to deer-mating
;  ifelse (aim > 30)
;  [set ter 1.5
;    set nm (1 + random 6)
;    set anm 0
;  ]
;  [set ter 2.5
;    set nm (1 + random 3)
;    set anm 0
;  ]
;  set tnm nm
;  let female-deer-near-me deers in-radius-nowrap ter with [sex = 2 and anm < nm]
;  let pmates (count female-deer-near-me)
;  if (pmates > 0)[
;    ifelse (cwd = 1)
;    [set infm 1]
;    [set infm 0]
;    ifelse (pmates >= tnm)
;    [set avmates tnm]
;    [set avmates pmates]
;    ask n-of avmates female-deer-near-me [
;      ifelse (cwd = 1)
;      [set inff 1
;        set tinff (tinff + 1)]
;      [if (infm = 1)[
;          if (random-float 1 < (.4 + random-float .2))[
;            set cwd 1
;          ]
;      ]
;      ]
;      set anm (anm + 1)
;    ]
;    if (tinff > 0)[
;      if (cwd = 0)[
;        repeat tinff [
;          if (random-float 1 < (.4 + random-float .2))[
;            set cwd 1
;          ]
;        ]
;      ]
;      set tinff 0
;    ]
;    set anm avmates
;  ]
;end
;




@#$#@#$#@
GRAPHICS-WINDOW
502
10
885
649
-1
-1
15.0
1
10
1
1
1
0
1
1
1
0
24
0
41
1
1
1
ticks
30.0

BUTTON
430
11
494
44
SETUP
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
1074
315
1141
360
total deer
count deers
17
1
11

MONITOR
1072
219
1143
264
male deer
count deers with [sex = 1]
17
1
11

MONITOR
1074
267
1142
312
female deer
count deers with [sex = 2]
17
1
11

MONITOR
1098
50
1199
95
male adult deer
mad
17
1
11

MONITOR
1097
98
1199
143
male yearling deer
myd
17
1
11

MONITOR
1098
147
1200
192
male fawn deer
mfd
17
1
11

MONITOR
1202
50
1312
95
female adult deer
fad
17
1
11

MONITOR
1203
97
1312
142
female yearling deer
fyd
17
1
11

MONITOR
1205
146
1313
191
female fawn deer
ffd
17
1
11

SLIDER
134
165
308
198
mf6nhm
mf6nhm
0
.1
0.055
.001
1
NIL
HORIZONTAL

SLIDER
135
204
307
237
ff6nhm
ff6nhm
0
.1
0.055
.001
1
NIL
HORIZONTAL

SLIDER
135
245
307
278
mf12nhm
mf12nhm
0
1
0.05
.01
1
NIL
HORIZONTAL

SLIDER
134
284
306
317
ff12nhm
ff12nhm
0
1
0.05
.01
1
NIL
HORIZONTAL

SLIDER
314
324
486
357
myhm
myhm
0
1
0.25
.01
1
NIL
HORIZONTAL

SLIDER
314
361
486
394
fyhm
fyhm
0
1
0.15
.01
1
NIL
HORIZONTAL

SLIDER
134
325
306
358
mynhm
mynhm
0
1
0.01
.01
1
NIL
HORIZONTAL

SLIDER
135
362
307
395
fynhm
fynhm
0
1
0.0
0.01
1
NIL
HORIZONTAL

SLIDER
314
402
486
435
mahm
mahm
0
1
0.4
.01
1
NIL
HORIZONTAL

SLIDER
315
440
487
473
fahm
fahm
0
1
0.2
.001
1
NIL
HORIZONTAL

SLIDER
134
404
306
437
manhm
manhm
0
1
0.01
.01
1
NIL
HORIZONTAL

SLIDER
133
443
305
476
fanhm
fanhm
0
1
0.02
.01
1
NIL
HORIZONTAL

BUTTON
430
51
493
84
GO
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
1153
223
1323
351
deer population
months
deer
0.0
10.0
0.0
15000.0
true
false
"" ""
PENS
"pen-0" 1.0 0 -2674135 true "" ""

SLIDER
316
165
484
198
mf6hm
mf6hm
0
0
0.0
0
1
NIL
HORIZONTAL

SLIDER
316
202
484
235
ff6hm
ff6hm
0
0
0.0
0
1
NIL
HORIZONTAL

SLIDER
313
243
485
276
mf12hm
mf12hm
0
1
0.05
.01
1
NIL
HORIZONTAL

SLIDER
314
282
486
315
ff12hm
ff12hm
0
1
0.02
.01
1
NIL
HORIZONTAL

SLIDER
18
655
190
688
tp
tp
0
1
0.01
.005
1
NIL
HORIZONTAL

SLIDER
18
693
190
726
pertest
pertest
0
1
0.01
.005
1
NIL
HORIZONTAL

SLIDER
193
654
365
687
npd
npd
0
100
0.0
10
1
NIL
HORIZONTAL

SLIDER
193
694
365
727
%CWDlandscape
%CWDlandscape
0
100
25.0
5
1
NIL
HORIZONTAL

SLIDER
17
735
189
768
permah
permah
0
.25
0.23
.01
1
NIL
HORIZONTAL

SLIDER
195
735
367
768
perfah
perfah
0
.80
0.79
.01
1
NIL
HORIZONTAL

PLOT
1161
396
1321
516
Doe group size
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "histogram [gr] of deers with [gl = 1]"

PLOT
991
396
1151
516
Bachelor group size
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "histogram [gr] of deers with [ml > 0]"

TEXTBOX
1123
25
1314
53
INITIAL AGE-SEX COMPOSITION
11
15.0
1

TEXTBOX
24
177
133
195
Young male fawns
11
0.0
1

TEXTBOX
142
144
292
162
NON-HUNTING MORTALITY
11
15.0
1

TEXTBOX
346
145
464
163
HUNTING MORTALITY
11
15.0
1

TEXTBOX
24
218
129
236
Young female fawns
11
0.0
1

TEXTBOX
26
256
114
277
Older male fawns
11
0.0
1

TEXTBOX
25
296
132
314
Older female fawns
11
0.0
1

TEXTBOX
26
335
107
353
Male yearlings
11
0.0
1

TEXTBOX
26
372
119
390
Female yearlings
11
0.0
1

TEXTBOX
27
410
104
428
Male adults
11
0.0
1

TEXTBOX
27
450
105
468
Female adults
11
0.0
1

CHOOSER
2
10
209
55
Region
Region
"BooneCounty" "CallawayCounty" "CarrollCounty" "CharitonCounty" "ColeCounty" "CooperCounty" "FranklinCounty" "GasconadeCounty" "KnoxCounty" "LinnCounty" "LivingstonCounty" "MillerCounty" "MoniteauCounty" "MorganCounty" "OsageCounty" "PutnamCounty" "RandolphCounty" "StCharlesCounty" "StLouisCounty" "SchuylerCounty" "ScotlandCounty" "ShelbyCounty" "SullivanCounty" "WarrenCounty" "WashingtonCounty"
0

SLIDER
1
59
211
92
PostHarvestDensity
PostHarvestDensity
0
50
18.0
1
1
per sq. mile
HORIZONTAL

SLIDER
223
10
422
43
sexratio
sexratio
0
200
120.0
10
1
females per 100 males
HORIZONTAL

SLIDER
224
45
422
78
adultprop
adultprop
0
1
0.4
.05
1
NIL
HORIZONTAL

SLIDER
224
80
421
113
yearlingprop
yearlingprop
0
1
0.25
.05
1
NIL
HORIZONTAL

SWITCH
1
105
212
138
Recommended_parameter_values
Recommended_parameter_values
1
1
-1000

CHOOSER
6
549
98
594
machine
machine
"PC" "belsarea"
0

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

deer
false
0
Polygon -7500403 true true 195 210 210 255 195 240 180 195 165 165 135 165 105 165 75 165 72 211 60 210 60 180 45 150 45 120 30 90 45 105 180 105 225 45 225 60 270 90 255 90 225 90 180 150
Polygon -7500403 true true 73 210 86 251 75 240 60 210
Polygon -7500403 true true 45 105 30 75 30 90 45 105 60 120 45 120
Line -7500403 true 210 60 165 15
Line -7500403 true 225 60 255 45
Line -7500403 true 195 45 210 15
Line -7500403 true 255 45 255 30
Line -7500403 true 255 45 270 30
Line -7500403 true 195 15 180 30

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="op_tp" repetitions="1" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>hcwd</metric>
    <metric>tcwd</metric>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <steppedValueSet variable="tp" first="0.01" step="0.01" last="0.1"/>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <steppedValueSet variable="pertest" first="0.01" step="0.01" last="0.1"/>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.2"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="1yearX100" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>totcwdd</metric>
    <metric>hcwd</metric>
    <metric>tcwd</metric>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tp">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pertest">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="prob_det_CWD" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>pdcwd</metric>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <steppedValueSet variable="tp" first="0.01" step="0.01" last="0.1"/>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <steppedValueSet variable="pertest" first="0.01" step="0.01" last="0.1"/>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="pdet_.001_.005_.01" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>pdcwd</metric>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tp">
      <value value="0.001"/>
      <value value="0.005"/>
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pertest">
      <value value="0.01"/>
      <value value="0.02"/>
      <value value="0.03"/>
      <value value="0.04"/>
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="samp_strategy_20141006" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>pdcwd</metric>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pertest">
      <value value="0.005"/>
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tp">
      <value value="0.005"/>
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="baseline_sampling_strategy" repetitions="1000" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>pdcwd</metric>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pertest">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tp">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="revmod" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>tcwd</metric>
    <metric>op</metric>
    <enumeratedValueSet variable="pertest">
      <value value="0.01"/>
      <value value="0.02"/>
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tp">
      <value value="0.005"/>
      <value value="0.01"/>
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.196"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="%CWDlandscape">
      <value value="25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="CL_MB" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>tcwd</metric>
    <metric>op</metric>
    <enumeratedValueSet variable="%CWDlandscape">
      <value value="25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="npd">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famonh">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymoh">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mymonh">
      <value value="0.01"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymonh">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="disp_rate">
      <value value="0.45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="pertest">
      <value value="0.01"/>
      <value value="0.02"/>
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mamoh">
      <value value="0.4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo12h">
      <value value="0.02"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="famoh">
      <value value="0.196"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ffmo6h">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo12h">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mfmo6">
      <value value="0.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="fymoh">
      <value value="0.15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tp">
      <value value="0.005"/>
      <value value="0.01"/>
      <value value="0.02"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
